<?php

namespace Addons\HaoTeamEmail\Controller;

use Home\Controller\AddonsController;

class HaoTeamEmailController extends AddonsController {

    /**
     * 后台首页-邮件配置
     * @param string $id
     * autor:Marvin9002
     */
    public function saveConfig() {

        if ($_POST['config'] && is_array($_POST['config'])) {
            $Config = M('Config');
            foreach ($_POST['config'] as $name => $value) {
                $map = array('name' => $name);
                $Config->where($map)->setField('value', $value);
            }
        }
        S('DB_CONFIG_DATA', null);
        $this->success('编辑成功。');
    }

    /**
     * 发送注册邮件
     * autor:Tiger
     */
    public function sendRegister($uid) {
        $where = array('id' => $uid);
        $db = M('ucenter_member');
        $server_host = "http://" . $_SERVER ['HTTP_HOST'];
        $Member = $db->where($where)->field('username,password,email')->find();
        $body = '尊敬的客户，欢迎您注册成为' . C('WEB_SITE_TITLE') . '用户。请牢记以下信息：<br>您的用户名是：' . $Member['username'] . '<br>您的注册邮箱为：' . $Member['email'] . '<hr><a href=' . $server_host . '>' . C('WEB_SITE_TITLE') . '</a>';
        //发送邮件
        include dirname(__FILE__) . './../Common/function.php';
        sendmail($Member['email'], '注册提醒邮件', $body);
    }

    /**
     * 发送找回密码邮件
     * autor:Tiger
     */
    public function renPassword($email, $url) {
        include dirname(__FILE__) . './../Common/function.php';
        $server_host = "http://" . $_SERVER ['HTTP_HOST'] . $url;
        $token = think_encrypt($email, C('DATA_AUTH_KEY'), '86400');
        $body = '亲爱的' . $email . '：<br>
欢迎使用' . C('WEB_SITE_TITLE') . '找回密码功能。<br>
请您点击此链接来修改您的密码：<a href=' . $server_host . '/token/' . $token . '>' . $server_host . '/token/' . $token . '</a>。<br>
如果您并未发过此请求，则可能是因为其他用户在尝试重设密码时误输入了您的电子邮件地址而使您收到这封邮件，那么您可以放心的忽略此邮件，无需进一步采取任何操作。<br>
此致<br>' . C('WEB_SITE_TITLE') . '敬上<br>';
        sendmail($email, '重置密码邮件', $body);
    }

}
